package org.apache.bcel.generic;

import java.io.DataOutputStream;
import java.io.IOException;

public class GOTO extends GotoInstruction implements VariableLengthInstruction {
   GOTO() {
   }

   public GOTO(InstructionHandle target) {
      super((short)167, target);
   }

   public void accept(Visitor v) {
      v.visitVariableLengthInstruction(this);
      v.visitUnconditionalBranch(this);
      v.visitBranchInstruction(this);
      v.visitGotoInstruction(this);
      v.visitGOTO(this);
   }

   public void dump(DataOutputStream out) throws IOException {
      super.setIndex(this.getTargetOffset());
      short opcode = this.getOpcode();
      if (opcode == 167) {
         super.dump(out);
      } else {
         super.setIndex(this.getTargetOffset());
         out.writeByte(opcode);
         out.writeInt(super.getIndex());
      }

   }

   protected int updatePosition(int offset, int maxOffset) {
      int i = this.getTargetOffset();
      this.setPosition(this.getPosition() + offset);
      if (Math.abs(i) >= 32767 - maxOffset) {
         super.setOpcode((short)200);
         short oldLength = (short)super.getLength();
         super.setLength(5);
         return super.getLength() - oldLength;
      } else {
         return 0;
      }
   }
}
